/*
 * Copyright (C) 2017 Centro de Computacao Cientifica e Software Livre
 * Departamento de Informatica - Universidade Federal do Parana
 *
 * This file is part of blendb.
 *
 * blendb is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * blendb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with blendb.  If not, see <http://www.gnu.org/licenses/>.
 */

import * as request from "supertest";
import { expect } from "chai";
import * as server from "../../main";

describe("API engine controller", () => {

    it("should respond 200 and the list of metrics", (done) => {
        request(server)
            .get("/v1/metrics")
            .expect(200)
            .expect((res: any) => {
                let result = res.body;
                expect(result).to.be.an("array");
                expect(result).to.have.length(16);
            })
            .end(done);
    });
    it("should respond 200 and the list of sources", (done) => {
        request(server)
            .get("/v1/sources")
            .expect(200)
            .expect((res: any) => {
                let result = res.body;
                expect(result).to.be.an("array");
                expect(result).to.have.length(8);
            })
            .end(done);
    });
    it("should respond 200 and the list of dimensions", (done) => {
        request(server)
            .get("/v1/dimensions")
            .expect(200)
            .expect((res: any) => {
                let result = res.body;
                expect(result).to.be.an("array");
                expect(result).to.have.length(19);
            })
            .end(done);
    });
    it("should respond 200 and the list of enumTypes", (done) => {
        request(server)
            .get("/v1/enumtypes")
            .expect((res: any) => {
                let result = res.body;
                expect(result).to.be.an("array");
                expect(result).to.have.length(3);
            })
            .end(done);
    });

});
